# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

"""
This script talks to the taskcluster secrets service to obtain the
Nimbledroid account key and upload Klar and Focus apk to Nimbledroid for perf analysis.
"""

import requests
import json
import urllib2
import os
import sys

url = "https://nimbledroid.com/api/v2/apks"

def uploadApk(apk,key):
	headers = {"Accept":"*/*"}
	payload = {'auto_scenarios':'false', 'device_config': 'android5,android7'}
	response = requests.post(url, auth=(key, ''), headers=headers, files=apk, data=payload)

	if response.status_code != 201:
		print('Status:', response.status_code, 'Headers:', response.headers, 'Error Response:',response.json())
		exit(1)

	# Print Response Details
	print 'Response Status Code:', response.status_code

	print ''
	print('Reponse Payload:')
	print json.dumps(response.json(), indent=4)


apk_path = sys.argv[1]
token_file = sys.argv[2]

with open(token_file) as f:
	key = f.read()

if key.rstrip() == '--':
	print('Nimbledroid key "--" detected. Not uploading anything to the service.')
	sys.exit(0)

with open(apk_path) as apk_file:
	uploadApk({'apk': apk_file}, key)
